monstertiles = {1,2,3}
entiremob_amount = 150
NPC_ID = 1 -- 1 = Zombie

function tablelength(tbl_l)
  local amounttbl = 0
	for i in pairs(tbl_l) do 
	amounttbl = amounttbl + 1
	end
  return amounttbl
end

function xyontile(x,y,wantedframe)
	if tile(x,y,"frame") == wantedframe then
		return true;
	else
		return false;
	end
end

listspawntiles = {}
function createlistspawntiles()
	for x = 0,map("xsize"),1 do 
		for y = 0,map("ysize"),1 do 
			for wantedframe in pairs(monstertiles) do
				if xyontile(x,y,wantedframe) == true then
					table.insert(listspawntiles, {x,y})
			end
			end
		end
	end
end
createlistspawntiles()

function spawn_random_mob()
	if #listspawntiles ~= 0 then
		local selectnum = math.random(1,#listspawntiles)
			if objectat(listspawntiles[selectnum][1],listspawntiles[selectnum][2],30) == 0 then
				parse('spawnobject 30 '..((listspawntiles[selectnum][1] * 32)+16)..' '..((listspawntiles[selectnum][2] * 32)+16) ..' '..math.random(0,360)..' 0 0 '..NPC_ID..'')
			end
	end
end

half_xsize = map("xsize") / 2
half_ysize = map("ysize") / 2
radius_for_entire = math.sqrt( math.pow(half_xsize, 2) + math.pow(half_ysize, 2) )

addhook('minute','_minute')
function _minute()
	local objectlist=closeobjects(half_xsize*32-16,half_ysize*32-16,radius_for_entire*32,30)
	npcalive = {}
		for _,id in pairs(objectlist) do
			npcalive[id] = "npc"
		end
		if tablelength(npcalive) < entiremob_amount then
			for variable = 0, (entiremob_amount-tablelength(npcalive)), 1 do
				spawn_random_mob()
			end
		end
--	msg(tablelength(npcalive)) FOR CHECKING THE AMOUNT OF NPCS!!
end

function spawnallmobs()
	for variable = 0, entiremob_amount, 1 do
		spawn_random_mob()
	end
end
spawnallmobs()